Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgTerrain::DataSet Class Reference

Inheritance diagram for osgTerrain::DataSet:

[legend]
List of all members.

## Public Types
typedef std::map< unsigned int, CompositeDestination * > | Row
typedef std::map< unsigned int, Row > | Level
typedef std::map< unsigned int, Level > | QuadMap
enum | CompositeType { GROUP, LOD, PAGED_LOD }
enum | DatabaseType { LOD_DATABASE, PagedLOD_DATABASE }
enum | GeometryType { HEIGHT_FIELD, POLYGONAL }
enum | TextureType { RGB_24, RGBA, RGB_16, RGBA_16, COMPRESSED_TEXTURE, COMPRESSED_RGBA_TEXTURE }
enum | MipMappingMode { NO_MIP_MAPPING, MIP_MAPPING_HARDWARE, MIP_MAPPING_IMAGERY }
## Public Member Functions
void | insertTileToQuadMap (CompositeDestination *tile)
DestinationTile * | getTile (unsigned int level, unsigned int X, unsigned int Y)
CompositeDestination * | getComposite (unsigned int level, unsigned int X, unsigned int Y)
Row & | getRow (unsigned int level, unsigned int Y)
| DataSet ()
void | addSource (Source *source)
void | addSource (CompositeSource *composite)
void | loadSources ()
void | setMaximumTileImageSize (unsigned int size)
unsigned int | getMaximumTileImageSize () const
void | setMaximumTileTerrainSize (unsigned int size)
unsigned int | getMaximumTileTerrainSize () const
void | setMaximumVisibleDistanceOfTopLevel (float d)
float | getMaximumVisibleDistanceOfTopLevel () const
void | setRadiusToMaxVisibleDistanceRatio (float ratio)
float | getRadiusToMaxVisibleDistanceRatio () const
void | setVerticalScale (float verticalScale)
float | getVerticalScale () const
void | setSkirtRatio (float skirtRatio)
float | getSkirtRatio () const
void | setDefaultColor (const osg::Vec4 &defaultColor)
const osg::Vec4 & | getDefaultColor () const
void | setDestinationCoordinateSystem (const std::string &wellKnownText)
void | setDestinationCoordinateSystem (osg::CoordinateSystemNode *cs)
osg::CoordinateSystemNode * | getDestinationCoordinateSystem ()
void | setIntermediateCoordinateSystem (const std::string &wellKnownText)
void | setIntermediateCoordinateSystem (osg::CoordinateSystemNode *cs)
osg::CoordinateSystemNode * | getIntermediateCoordinateSystem ()
void | setConvertFromGeographicToGeocentric (bool flag)
bool | getConvertFromGeographicToGeocentric () const
void | setEllipsoidModel (osg::EllipsoidModel *et)
osg::EllipsoidModel * | getEllipsoidModel ()
const osg::EllipsoidModel * | getEllipsoidModel () const
bool | mapLatLongsToXYZ () const
void | setDestinationExtents (const osg::BoundingBox &extents)
void | setDestinationGeoTransform (const osg::Matrixd &geoTransform)
void | setArchiveName (const std::string &filename)
| Set the Archive name if one is to be used.
const std::string & | getArchiveName () const
| Get the Archive name.
void | setArchive (osgDB::Archive *archive)
| Set the Archive.
osgDB::Archive * | getArchive ()
| Get the Archive if one is to being used.
void | setDestinationName (const std::string &filename)
| Set the Directory, DestinationTileBaseName and DestinationTileExtension from the passed in filename.
void | setDirectory (const std::string &directory)
const std::string & | getDirectory () const
void | setDestinationTileBaseName (const std::string &basename)
const std::string & | getDestinationTileBaseName () const
void | setDestinationTileExtension (const std::string &extension)
const std::string & | getDestinationTileExtension () const
void | setDestinationImageExtension (const std::string &extension)
const std::string & | getDestinationImageExtension () const
void | setDatabaseType (DatabaseType type)
DatabaseType | getDatabaseType () const
void | setGeometryType (GeometryType type)
GeometryType | getGeometryType () const
void | setTextureType (TextureType type)
TextureType | getTextureType () const
void | setMaxAnisotropy (float d)
float | getMaxAnisotropy () const
void | setMipMappingMode (MipMappingMode mipMappingMode)
MipMappingMode | getMipMappingMode () const
void | setUseLocalTileTransform (bool flag)
bool | getUseLocalTileTransform () const
void | setDecorateGeneratedSceneGraphWithCoordinateSystemNode (bool flag)
bool | getDecorateGeneratedSceneGraphWithCoordinateSystemNode () const
void | setDecorateGeneratedSceneGraphWithMultiTextureControl (bool flag)
bool | getDecorateGeneratedSceneGraphWithMultiTextureControl () const
unsigned int | getNumOfTextureLevels () const
void | setCommentString (const std::string &comment)
const std::string & | getCommentString () const
void | setWriteNodeBeforeSimplification (bool flag)
bool | getWriteNodeBeforeSimplification () const
CompositeDestination * | createDestinationGraph (CompositeDestination *parent, osg::CoordinateSystemNode *cs, const osg::BoundingBox &extents, unsigned int maxImageSize, unsigned int maxTerrainSize, unsigned int currentLevel, unsigned int currentX, unsigned int currentY, unsigned int maxNumLevels)
void | computeDestinationGraphFromSources (unsigned int numLevels)
void | updateSourcesForDestinationGraphNeeds ()
void | populateDestinationGraphFromSources ()
void | createDestination (unsigned int numLevels)
void | buildDestination ()
void | writeDestination ()
osg::Node * | getDestinationRootNode ()
void | _writeNodeFile (const osg::Node &node, const std::string &filename)
void | _writeImageFile (const osg::Image &image, const std::string &filename)
void | setState (osg::State *state)
osg::State * | getState ()
## Static Public Member Functions
std::string | coordinateSystemStringToWTK (const std::string &coordinateSystem)
void | setNotifyOffset (int level)
int | setNotifyOffset ()
## Protected Member Functions
virtual | ~DataSet ()
void | _readRow (Row &row)
void | _equalizeRow (Row &row)
void | _writeRow (Row &row)
void | _buildDestination (bool writeToDisk)
void | init ()
osg::Node * | decorateWithCoordinateSystemNode (osg::Node *subgraph)
osg::Node * | decorateWithMultiTextureControl (osg::Node *subgraph)
## Protected Attributes
osg::ref_ptr< CompositeSource > | _sourceGraph
osg::ref_ptr< CompositeDestination > | _destinationGraph
QuadMap | _quadMap
unsigned int | _maximumTileImageSize
unsigned int | _maximumTileTerrainSize
float | _maximumVisiableDistanceOfTopLevel
float | _radiusToMaxVisibleDistanceRatio
float | _verticalScale
float | _skirtRatio
osg::ref_ptr< osg::CoordinateSystemNode > | _destinationCoordinateSystem
osg::ref_ptr< osg::CoordinateSystemNode > | _intermediateCoordinateSystem
bool | _convertFromGeographicToGeocentric
osg::ref_ptr< osg::EllipsoidModel > | _ellipsoidModel
osg::Matrixd | _geoTransform
osg::BoundingBox | _extents
std::string | _archiveName
osg::ref_ptr< osgDB::Archive > | _archive
std::string | _directory
std::string | _tileBasename
std::string | _tileExtension
std::string | _imageExtension
osg::Vec4 | _defaultColor
DatabaseType | _databaseType
GeometryType | _geometryType
TextureType | _textureType
float | _maxAnisotropy
MipMappingMode | _mipMappingMode
unsigned int | _numTextureLevels
bool | _useLocalTileTransform
bool | _decorateWithCoordinateSystemNode
bool | _decorateWithMultiTextureControl
std::string | _comment
bool | _writeNodeBeforeSimplification
osg::ref_ptr< osg::Node > | _rootNode
osg::ref_ptr< osg::State > | _state

## Member Typedef Documentation

typedef std::map<unsigned int,Row> osgTerrain::DataSet::Level

typedef std::map<unsigned int,Level> osgTerrain::DataSet::QuadMap

typedef std::map<unsigned int,CompositeDestination*> osgTerrain::DataSet::Row

## Member Enumeration Documentation

enum osgTerrain::DataSet::CompositeType

  | Enumeration values:
  GROUP |
  LOD |
  PAGED_LOD |

enum osgTerrain::DataSet::DatabaseType

  | Enumeration values:
  LOD_DATABASE |
  PagedLOD_DATABASE |

enum osgTerrain::DataSet::GeometryType

  | Enumeration values:
  HEIGHT_FIELD |
  POLYGONAL |

enum osgTerrain::DataSet::MipMappingMode

  | Enumeration values:
  NO_MIP_MAPPING |
  MIP_MAPPING_HARDWARE | disable mip mapping - use LINEAR, LINEAR filters.
  MIP_MAPPING_IMAGERY | use mip mapping, and store imagery along with associated mip maps.

enum osgTerrain::DataSet::TextureType

  | Enumeration values:
  RGB_24 |
  RGBA |
  RGB_16 |
  RGBA_16 |
  COMPRESSED_TEXTURE |
  COMPRESSED_RGBA_TEXTURE |

## Constructor & Destructor Documentation

osgTerrain::DataSet::DataSet | ( |  | ) |

virtual osgTerrain::DataSet::~DataSet | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

void osgTerrain::DataSet::_buildDestination | ( | bool | writeToDisk | ) | `[protected]`

void osgTerrain::DataSet::_equalizeRow | ( | Row & | row | ) | `[protected]`

void osgTerrain::DataSet::_readRow | ( | Row & | row | ) | `[protected]`

void osgTerrain::DataSet::_writeImageFile | ( | const osg::Image & | image,
|  | const std::string & | filename
| ) |

void osgTerrain::DataSet::_writeNodeFile | ( | const osg::Node & | node,
|  | const std::string & | filename
| ) |

void osgTerrain::DataSet::_writeRow | ( | Row & | row | ) | `[protected]`

void osgTerrain::DataSet::addSource | ( | CompositeSource * | composite | ) |

void osgTerrain::DataSet::addSource | ( | Source * | source | ) |

void osgTerrain::DataSet::buildDestination | ( |  | ) | `[inline]`

void osgTerrain::DataSet::computeDestinationGraphFromSources | ( | unsigned int | numLevels | ) |

std::string osgTerrain::DataSet::coordinateSystemStringToWTK | ( | const std::string & | coordinateSystem | ) | `[static]`

void osgTerrain::DataSet::createDestination | ( | unsigned int | numLevels | ) |

CompositeDestination* osgTerrain::DataSet::createDestinationGraph | ( | CompositeDestination * | parent,
|  | osg::CoordinateSystemNode * | cs,
|  | const osg::BoundingBox & | extents,
|  | unsigned int | maxImageSize,
|  | unsigned int | maxTerrainSize,
|  | unsigned int | currentLevel,
|  | unsigned int | currentX,
|  | unsigned int | currentY,
|  | unsigned int | maxNumLevels
| ) |

osg::Node* osgTerrain::DataSet::decorateWithCoordinateSystemNode | ( | osg::Node * | subgraph | ) | `[protected]`

osg::Node* osgTerrain::DataSet::decorateWithMultiTextureControl | ( | osg::Node * | subgraph | ) | `[protected]`

osgDB::Archive* osgTerrain::DataSet::getArchive | ( |  | ) | `[inline]`

| Get the Archive if one is to being used.

const std::string& osgTerrain::DataSet::getArchiveName | ( |  | ) | const`[inline]`

| Get the Archive name.

const std::string& osgTerrain::DataSet::getCommentString | ( |  | ) | const`[inline]`

CompositeDestination* osgTerrain::DataSet::getComposite | ( | unsigned int | level,
|  | unsigned int | X,
|  | unsigned int | Y
| ) | `[inline]`

bool osgTerrain::DataSet::getConvertFromGeographicToGeocentric | ( |  | ) | const`[inline]`

DatabaseType osgTerrain::DataSet::getDatabaseType | ( |  | ) | const`[inline]`

bool osgTerrain::DataSet::getDecorateGeneratedSceneGraphWithCoordinateSystemNode | ( |  | ) | const`[inline]`

bool osgTerrain::DataSet::getDecorateGeneratedSceneGraphWithMultiTextureControl | ( |  | ) | const`[inline]`

const osg::Vec4& osgTerrain::DataSet::getDefaultColor | ( |  | ) | const`[inline]`

osg::CoordinateSystemNode* osgTerrain::DataSet::getDestinationCoordinateSystem | ( |  | ) | `[inline]`

const std::string& osgTerrain::DataSet::getDestinationImageExtension | ( |  | ) | const`[inline]`

osg::Node* osgTerrain::DataSet::getDestinationRootNode | ( |  | ) | `[inline]`

const std::string& osgTerrain::DataSet::getDestinationTileBaseName | ( |  | ) | const`[inline]`

const std::string& osgTerrain::DataSet::getDestinationTileExtension | ( |  | ) | const`[inline]`

const std::string& osgTerrain::DataSet::getDirectory | ( |  | ) | const`[inline]`

const osg::EllipsoidModel* osgTerrain::DataSet::getEllipsoidModel | ( |  | ) | const`[inline]`

osg::EllipsoidModel* osgTerrain::DataSet::getEllipsoidModel | ( |  | ) | `[inline]`

GeometryType osgTerrain::DataSet::getGeometryType | ( |  | ) | const`[inline]`

osg::CoordinateSystemNode* osgTerrain::DataSet::getIntermediateCoordinateSystem | ( |  | ) | `[inline]`

float osgTerrain::DataSet::getMaxAnisotropy | ( |  | ) | const`[inline]`

unsigned int osgTerrain::DataSet::getMaximumTileImageSize | ( |  | ) | const`[inline]`

unsigned int osgTerrain::DataSet::getMaximumTileTerrainSize | ( |  | ) | const`[inline]`

float osgTerrain::DataSet::getMaximumVisibleDistanceOfTopLevel | ( |  | ) | const`[inline]`

MipMappingMode osgTerrain::DataSet::getMipMappingMode | ( |  | ) | const`[inline]`

unsigned int osgTerrain::DataSet::getNumOfTextureLevels | ( |  | ) | const`[inline]`

float osgTerrain::DataSet::getRadiusToMaxVisibleDistanceRatio | ( |  | ) | const`[inline]`

Row& osgTerrain::DataSet::getRow | ( | unsigned int | level,
|  | unsigned int | Y
| ) | `[inline]`

float osgTerrain::DataSet::getSkirtRatio | ( |  | ) | const`[inline]`

osg::State* osgTerrain::DataSet::getState | ( |  | ) | `[inline]`

TextureType osgTerrain::DataSet::getTextureType | ( |  | ) | const`[inline]`

DestinationTile* osgTerrain::DataSet::getTile | ( | unsigned int | level,
|  | unsigned int | X,
|  | unsigned int | Y
| ) | `[inline]`

bool osgTerrain::DataSet::getUseLocalTileTransform | ( |  | ) | const`[inline]`

float osgTerrain::DataSet::getVerticalScale | ( |  | ) | const`[inline]`

bool osgTerrain::DataSet::getWriteNodeBeforeSimplification | ( |  | ) | const`[inline]`

void osgTerrain::DataSet::init | ( |  | ) | `[protected]`

void osgTerrain::DataSet::insertTileToQuadMap | ( | CompositeDestination * | tile | ) | `[inline]`

void osgTerrain::DataSet::loadSources | ( |  | ) |

bool osgTerrain::DataSet::mapLatLongsToXYZ | ( |  | ) | const`[inline]`

void osgTerrain::DataSet::populateDestinationGraphFromSources | ( |  | ) |

void osgTerrain::DataSet::setArchive | ( | osgDB::Archive * | archive | ) | `[inline]`

| Set the Archive.

void osgTerrain::DataSet::setArchiveName | ( | const std::string & | filename | ) | `[inline]`

| Set the Archive name if one is to be used.

void osgTerrain::DataSet::setCommentString | ( | const std::string & | comment | ) | `[inline]`

void osgTerrain::DataSet::setConvertFromGeographicToGeocentric | ( | bool | flag | ) | `[inline]`

void osgTerrain::DataSet::setDatabaseType | ( | DatabaseType | type | ) | `[inline]`

void osgTerrain::DataSet::setDecorateGeneratedSceneGraphWithCoordinateSystemNode | ( | bool | flag | ) | `[inline]`

void osgTerrain::DataSet::setDecorateGeneratedSceneGraphWithMultiTextureControl | ( | bool | flag | ) | `[inline]`

void osgTerrain::DataSet::setDefaultColor | ( | const osg::Vec4 & | defaultColor | ) | `[inline]`

void osgTerrain::DataSet::setDestinationCoordinateSystem | ( | osg::CoordinateSystemNode * | cs | ) | `[inline]`

void osgTerrain::DataSet::setDestinationCoordinateSystem | ( | const std::string & | wellKnownText | ) | `[inline]`

void osgTerrain::DataSet::setDestinationExtents | ( | const osg::BoundingBox & | extents | ) | `[inline]`

void osgTerrain::DataSet::setDestinationGeoTransform | ( | const osg::Matrixd & | geoTransform | ) | `[inline]`

void osgTerrain::DataSet::setDestinationImageExtension | ( | const std::string & | extension | ) | `[inline]`

void osgTerrain::DataSet::setDestinationName | ( | const std::string & | filename | ) |

| Set the Directory, DestinationTileBaseName and DestinationTileExtension from the passed in filename.

void osgTerrain::DataSet::setDestinationTileBaseName | ( | const std::string & | basename | ) | `[inline]`

void osgTerrain::DataSet::setDestinationTileExtension | ( | const std::string & | extension | ) | `[inline]`

void osgTerrain::DataSet::setDirectory | ( | const std::string & | directory | ) |

void osgTerrain::DataSet::setEllipsoidModel | ( | osg::EllipsoidModel * | et | ) | `[inline]`

void osgTerrain::DataSet::setGeometryType | ( | GeometryType | type | ) | `[inline]`

void osgTerrain::DataSet::setIntermediateCoordinateSystem | ( | osg::CoordinateSystemNode * | cs | ) | `[inline]`

void osgTerrain::DataSet::setIntermediateCoordinateSystem | ( | const std::string & | wellKnownText | ) | `[inline]`

void osgTerrain::DataSet::setMaxAnisotropy | ( | float | d | ) | `[inline]`

void osgTerrain::DataSet::setMaximumTileImageSize | ( | unsigned int | size | ) | `[inline]`

void osgTerrain::DataSet::setMaximumTileTerrainSize | ( | unsigned int | size | ) | `[inline]`

void osgTerrain::DataSet::setMaximumVisibleDistanceOfTopLevel | ( | float | d | ) | `[inline]`

void osgTerrain::DataSet::setMipMappingMode | ( | MipMappingMode | mipMappingMode | ) | `[inline]`

int osgTerrain::DataSet::setNotifyOffset | ( |  | ) | `[static]`

void osgTerrain::DataSet::setNotifyOffset | ( | int | level | ) | `[static]`

void osgTerrain::DataSet::setRadiusToMaxVisibleDistanceRatio | ( | float | ratio | ) | `[inline]`

void osgTerrain::DataSet::setSkirtRatio | ( | float | skirtRatio | ) | `[inline]`

void osgTerrain::DataSet::setState | ( | osg::State * | state | ) | `[inline]`

void osgTerrain::DataSet::setTextureType | ( | TextureType | type | ) | `[inline]`

void osgTerrain::DataSet::setUseLocalTileTransform | ( | bool | flag | ) | `[inline]`

void osgTerrain::DataSet::setVerticalScale | ( | float | verticalScale | ) | `[inline]`

void osgTerrain::DataSet::setWriteNodeBeforeSimplification | ( | bool | flag | ) | `[inline]`

void osgTerrain::DataSet::updateSourcesForDestinationGraphNeeds | ( |  | ) |

void osgTerrain::DataSet::writeDestination | ( |  | ) | `[inline]`

## Member Data Documentation

osg::ref_ptr<osgDB::Archive> osgTerrain::DataSet::_archive`[protected]`

std::string osgTerrain::DataSet::_archiveName`[protected]`

std::string osgTerrain::DataSet::_comment`[protected]`

bool osgTerrain::DataSet::_convertFromGeographicToGeocentric`[protected]`

DatabaseType osgTerrain::DataSet::_databaseType`[protected]`

bool osgTerrain::DataSet::_decorateWithCoordinateSystemNode`[protected]`

bool osgTerrain::DataSet::_decorateWithMultiTextureControl`[protected]`

osg::Vec4 osgTerrain::DataSet::_defaultColor`[protected]`

osg::ref_ptr<osg::CoordinateSystemNode> osgTerrain::DataSet::_destinationCoordinateSystem`[protected]`

osg::ref_ptr<CompositeDestination> osgTerrain::DataSet::_destinationGraph`[protected]`

std::string osgTerrain::DataSet::_directory`[protected]`

osg::ref_ptr<osg::EllipsoidModel> osgTerrain::DataSet::_ellipsoidModel`[protected]`

osg::BoundingBox osgTerrain::DataSet::_extents`[protected]`

GeometryType osgTerrain::DataSet::_geometryType`[protected]`

osg::Matrixd osgTerrain::DataSet::_geoTransform`[protected]`

std::string osgTerrain::DataSet::_imageExtension`[protected]`

osg::ref_ptr<osg::CoordinateSystemNode> osgTerrain::DataSet::_intermediateCoordinateSystem`[protected]`

float osgTerrain::DataSet::_maxAnisotropy`[protected]`

unsigned int osgTerrain::DataSet::_maximumTileImageSize`[protected]`

unsigned int osgTerrain::DataSet::_maximumTileTerrainSize`[protected]`

float osgTerrain::DataSet::_maximumVisiableDistanceOfTopLevel`[protected]`

MipMappingMode osgTerrain::DataSet::_mipMappingMode`[protected]`

unsigned int osgTerrain::DataSet::_numTextureLevels`[protected]`

QuadMap osgTerrain::DataSet::_quadMap`[protected]`

float osgTerrain::DataSet::_radiusToMaxVisibleDistanceRatio`[protected]`

osg::ref_ptr<osg::Node> osgTerrain::DataSet::_rootNode`[protected]`

float osgTerrain::DataSet::_skirtRatio`[protected]`

osg::ref_ptr<CompositeSource> osgTerrain::DataSet::_sourceGraph`[protected]`

osg::ref_ptr<osg::State> osgTerrain::DataSet::_state`[protected]`

TextureType osgTerrain::DataSet::_textureType`[protected]`

std::string osgTerrain::DataSet::_tileBasename`[protected]`

std::string osgTerrain::DataSet::_tileExtension`[protected]`

bool osgTerrain::DataSet::_useLocalTileTransform`[protected]`

float osgTerrain::DataSet::_verticalScale`[protected]`

bool osgTerrain::DataSet::_writeNodeBeforeSimplification`[protected]`

The documentation for this class was generated from the following file:

- DataSet